use actix_identity::Identity;
use actix_web::{web, HttpResponse, Responder};
use serde::Deserialize;
use sqlx::PgPool;

use crate::models::availabillity::Availabillity;

#[derive(Deserialize)]
pub struct AvailabillityPath {
    pub id: i32
}

#[actix_web::delete("/availabillity/delete/{id}")]
pub async fn delete_availabillity(user: Identity, pool: web::Data<PgPool>, path: web::Path<AvailabillityPath>) -> impl Responder {
    if let Ok(current_user_id) = user.id() {
        let current_user_id: i32 = current_user_id.parse().unwrap();

        if let Ok(availabillity_in_db) = Availabillity::read_by_id(pool.get_ref(), path.id).await {
            if availabillity_in_db.user_id == current_user_id {
                if let Ok(_) = Availabillity::delete(pool.get_ref(), availabillity_in_db.id).await {
                    return HttpResponse::NoContent().finish();
                }
            }
        }
    }

    return HttpResponse::BadRequest().finish();
}
